import { OpeningElementVisitor } from "./opening-element-visitor";
import { ClosingElementVisitor } from "./closing-element-visitor";
import { JSXExpressionContainerVisitor } from "./jsx-expression-container-visitor";
export class TagGenerator {
    constructor(tag) {
        this.m_Tag = tag;
        this.m_Fragments = [];
    }
    Generate() {
        this.TraverseTag(this.m_Tag);
        return this.m_Fragments.join("");
    }
    TraverseTag(tag) {
        new OpeningElementVisitor().Visit(tag.get("openingElement"), this);
        tag.get("children").forEach(each => {
            if (each.isJSXElement()) {
                this.TraverseTag(each);
            }
            else if (each.isJSXText()) {
                this.TraverseText(each);
            }
            else if (each.isJSXExpressionContainer()) {
                new JSXExpressionContainerVisitor().Visit(each, this);
            }
        });
        new ClosingElementVisitor().Visit(tag.get("closingElement"), this);
    }
    Append(fragment) {
        this.m_Fragments.push(fragment);
    }
    TraverseText(text) {
        this.Append(text.node.value);
    }
}
